var userJson = null, timer = null;
var lastMessageId = 0;
var ajpush = null;
var chatId = 0;
function getconversationlist() {
	var url = 'api/v1/room/';
	if (userJson.usertype == 'a') {
		url = url + 'roomsbyasker1';
	} else {
		url = url + 'roomsbyconsultant1';
	}
	_ajax(url, {
	}, {
		Authorization : 'Bearer ' + userJson.access_token
	}, false, function(ret) {
		api.refreshHeaderLoadDone();
		if (ret) {
			var conversationlist = ret.conversations;
			// 渲染列表
			if (conversationlist && conversationlist.length > 0) {
				lastMessageId = conversationlist[0].lastmsgid;
				var interText = doT.template($("#msglistTpl").text());
				$("#msglist ul").html(interText(conversationlist));
				//显示全部
				showUnreadTotalCount();
			}
			//设置定时器，定时获得最新的会话列表变化，最后一个消息id，就不用时间了
			if (!timer)
				timer = window.setInterval(getnewconversation, window.conversationInternal);
		}
	});
}

function setlastmessage(msgtype, msgcontent) {
	var returnmsg = "";
	switch(msgtype) {
		// 文本类型
		case "text":
			returnmsg = "［文字］:" + msgcontent;
			break;
	}
	return returnmsg;
}

function getnewconversation() {
	if (lastMessageId > 0) {
		//获得会话列表
		_ajax('api/v1/room/getnewconversation', {
			lastMessageId : lastMessageId
		}, {
			Authorization : 'Bearer ' + userJson.access_token
		}, false, function(ret) {
			//获得列表后更新
			var conversations = ret.conversations;
			if (conversations && conversations.length > 0) {
				lastMessageId = conversations[conversations.length - 1].lastmsgid;
				for (var i = 0; i < conversations.length; i++) {
					var targetId = conversations[i].targetid;
					if (conversations[i].status > 0) {
						if ($("#msglist ul li[data-targetId='" + targetId + "']").size() > 0) {
							var $newMsg = $("#msglist ul li[data-targetId='" + targetId + "']");
							//							if ($newMsg.find(".unread").text() && $newMsg.find(".unread").text() != '') {
							//								$newMsg.find(".unread").text(parseInt($newMsg.find(".unread").text()) + 1);
							//							} else {
							//								$newMsg.find(".unread").text("1");
							//							}
							$newMsg.find(".msgnr").text(setlastmessage(conversations[i].lastmsgtype, conversations[i].lastmsgcontent));
							$newMsg.find(".btime").text(_formatDate(conversations[i].lastmsgtime));
							if (conversations[i].unreadcount > 0)
								$newMsg.find(".unread").text(conversations[i].unreadcount);
							var $clone = $newMsg.clone();
							// 移除
							$newMsg.remove();
							// 在第一次插入
							$('#msglist ul').prepend($clone);
						} else {
							var _arr = [];
							_arr.push(conversations[i]);
							var interText = doT.template($("#msglistTpl").text());
							$("#msglist ul").prepend(interText(_arr));
						}
					} else {
						if ($("#msglist ul li[data-targetId='" + targetId + "']").size() > 0) {
							$("#msglist ul li[data-targetId='" + targetId + "']").remove();
						}
					}
				}
				showUnreadTotalCount();
			}
		});
	} else {
		//如果一直没有，就一直刷
		api.refreshHeaderLoading();
	}
}

// 5.10 清除会话未读数
function clearunread(targetId) {
	if ($("#msglist ul li[data-targetId='" + targetId + "']").size() > 0) {
		var $newMsg = $("#msglist ul li[data-targetId='" + targetId + "']");
		$newMsg.find(".unread").text("");
	}
	//获得所有未读
	showUnreadTotalCount();
}

function showUnreadTotalCount() {
	var unreadlist = $api.domAll($api.byId('msglist'), '.unread');
	var total = 0;
	for (var i = 0; i < unreadlist.length; i++) {
		if ($api.text(unreadlist[i]) != '') {
			total = total + parseInt($api.text(unreadlist[i]));
		}
	}
	api.execScript({
		name : userJson.usertype == 'c' ? 'consultant1_win' : 'asker1_win',
		script : 'unreadtotal(' + total + ');'
	});
}

function openChatWin(targetId, status, app) {
	//先清理未读数
	clearunread(targetId);
	api.openWin({
		name : 'chat1_win',
		url : './chat1_win.html',
		pageParam : {
			targetId : targetId,
			status : status,
			app : app
		}
	});
}

//Zepto(function($) {
//	// 绑定会话点击事件
//	$("#msglist").on("click", "li", function() {
//		var targetId = $(this).attr("data-targetId");
//		var status = $(this).attr("data-status");
//		// 打开会话页面
//		api.openWin({
//			name : 'chat1_win',
//			url : './chat1_win.html',
//			pageParam : {
//				targetId : targetId,
//				status : status
//			}
//		});
//	});
//});

apiready = function() {
	userJson = $api.getStorage(window.userKey);
	//第一次调用，第一进入时刷新一次，以后以来手动和收到消息刷新
	api.setRefreshHeaderInfo({
		visible : true,
		bgColor : "#F3F2F0",
		textColor : "#999",
		textDown : '下拉刷新...',
		textUp : '松开刷新...',
		showTime : true
	}, function(ret, err) {
		getconversationlist();
	});
	setTimeout(function() {
		api.refreshHeaderLoading();
	}, 600);
	//只放到
	ajpush = api.require('ajpush');
	if (api.systemType == 'android') {
		ajpush.init(function(ret) {
			if (ret && ret.status) {
				//success
			}
		});
	}
	//清理状态栏消息
	ajpush.clearNotification(param, function(ret) {
		if (ret && ret.status) {
			//success
		}
	});
	var param = {
		alias : userJson.userid + '',
		tags : [userJson.usertype, 'all']
	};
	//绑定推送的用户
	ajpush.bindAliasAndTags(param, function(ret) {
		//首先进入页面是停止接收推送的android有效
		if (api.systemType == 'android') {
			ajpush.stopPush(function(ret) {
				if (ret && ret.status) {
					//success
				}
			});
		}
	});
	_addEventListener("logout", function(ret) {
		if (timer) {
			window.clearInterval(timer);
			timer = null;
		}
	});
	_addEventListener("clearunread", function(ret) {
		if (ret && ret.value) {
			clearunread(ret.value.targetId);
		}
	});
	api.addEventListener({
		name : 'pause'
	}, function(ret, err) {
		if (timer) {
			window.clearInterval(timer);
			timer = null;
		}
		//设置接收推送消息，启动android推送
		if (ajpush && api.systemType == 'android') {
			ajpush.resumePush(function(ret) {
				if (ret && ret.status) {
					//success
				}
			});
		}
	});
	api.addEventListener({
		name : 'resume'
	}, function(ret, err) {
		if (!timer)
			timer = window.setInterval(getnewconversation, window.conversationInternal);
		var param = {
			id : -1
		};
		if (ajpush) {
			//首先进入页面是停止接收推送的android有效
			if (api.systemType == 'android') {
				ajpush.stopPush(function(ret) {
					if (ret && ret.status) {
						//success
					}
				});
			}
			ajpush.clearNotification(param, function(ret) {
				if (ret && ret.status) {
					//success
				}
			});
		}
		//恢复后，马上拉一次消息
		getnewconversation();
	});
}
function getSortFun(order, sortBy) {
	var ordAlpah = (order == 'asc') ? '>' : '<';
	var sortFun = new Function('a', 'b', 'return a.' + sortBy + ordAlpah + 'b.' + sortBy + '?1:-1');
	return sortFun;
}