// 服务器地址
window.serverUrl = "http://192.168.31.169:8080/";
//window.serverUrl = "http://172.20.200.124:8080/";
//公司wifi
//window.serverUrl = "http://172.20.236.76:8080/";
//5楼
//window.serverUrl = "http://172.20.65.202:8080/";
//腾讯云主机
//window.serverUrl = "http://119.29.62.26:8080/";
window.serverUrl = "https://www.zhiliaoxl.com/";

window.uploadUrl = "https://192.168.31.169:8080/api/v1/";
//window.serverUrl = "http://wchild-apicloudim-linshiren.l213.vhostgo.com/index.php/Home/";
//window.uploadUrl = "http://wchild-apicloudim-linshiren.l213.vhostgo.com/";
// AC默认参数 BEGIN
window.openWinAnimationType = "movein";
window.openWinAnimationSubType = "from_right";
window.openWinAnimationDuration = 300;
window.openWinDelay = 300;
window.toastDuration = 3000;
window.toastLocation = "bottom";
window.showProgressAnimationType = "fade";
window.showProgressTitle = "";
window.showProgressText = "加载中...";
window.ajaxTimeout = 5000;
window.messageInternal = 7000;
window.conversationInternal = 5000;
// APP默认参数 END
// 用户偏好设置的Key
window.userKey = "userInfo";
window.welcomeKey = "welcomeShow";
window.notificationKey = "notificationSpan";

function _closeAllwin() {
	var allwin = ['aboutus_win', 'admin_consultant_edit_win', 'admin_consultant_win', 'admin_win', 'asker_win', 'bill_win', 'chat_win', 'chat_setting_win', 'consultant_win', 'guide_chat_win', 'guide_win', 'help_win', 'intro_win', 'joinus_win', 'kefu_win', 'login_win', 'mysetting_win', 'nickname_win', 'notification_win', 'password_win', 'phrasebook_win', 'post_win', 'price_win', 'price_one_win', 'privacy_win', 'profile_win', 'question_win', 'reg_win', 'setting_win', 'terms_win', 'worksheet_win'];
	for (var w in allwin) {
		api.closeWin({
			name : allwin[w]
		});
	}
}

// 双击退出应用
function _twoClickCloseApp(_call) {
	//定义个时间戳
	var mkeyTime = new Date().getTime();
	api.addEventListener({
		name : 'keyback'
	}, function(ret, err) {
		if ((new Date().getTime() - mkeyTime) > 2000) {
			mkeyTime = new Date().getTime();
			api.toast({
				msg : '再按一次退出程序',
				duration : window.toastDuration,
				location : window.toastLocation
			});
		} else {
			if ( typeof _call == "function") {
				_call();
			}
			// 静默关闭,不弹出关闭提示窗口
			api.closeWidget({
				silent : true
			});
		}
	});
}

// 禁止返回
function _stopBack(_call) {
	api.addEventListener({
		name : 'keyback'
	}, function(ret, err) {
		if ( typeof _call == "function") {
			_call(ret.data);
		}
	});
}

//ajax访问,全部使用异步访问
function _ajax(url, data, headers, async, _call) {
	$.ajax({
		type : 'POST',
		url : window.serverUrl + url,
		data : data,
		dataType : 'json',
		headers : headers,
		async : true,
		timeout : window.ajaxTimeout,
		success : function(data) {
			if ( typeof _call == "function") {
				_call(data);
			}
		},
		error : function(xhr, type, error) {
			api.hideProgress();
			api.refreshHeaderLoadDone();
			//如果未授权
			if (xhr.status == 401) {
				if ('api/login' == url) {
					api.toast({
						msg : '登录失败，邮件／密码不匹配！'
					});
				} else if ('api/validate' == url) {
					//当前界面上，直接显示
					showBody();
				} else {
					_sendEvent("logout", {});
					$api.rmStorage(window.userKey);
					api.alert({
						title : '用户授权已过期',
						msg : '请重新使用邮箱和密码进行登录！'
					}, function(ret, err) {
						_exit();
					});
				}
			} else {
				if ('api/validate' == url) {
					api.alert({
						title : '错误信息(' + xhr.status + ')',
						msg : '错误信息：访问服务器错误或网络不可用！请检查网络重试！'
					}, function(ret, err) {
						api.openWin({
							name : 'root',
							url : './index.html',
							reload : true
						});
					});
				} else if ('api/v1/message/getnewmessages' == url) {
					api.toast({
	                    msg : '服务器错误或网络不可用，正在重试！(' + xhr.status + ')'
                    });
				} else if ('api/v1/room/getnewconversation' == url) {
					api.toast({
	                    msg : '服务器错误或网络不可用，正在重试！(' + xhr.status + ')'
                    });
				} else {
					api.alert({
						title : '错误信息(' + xhr.status + ')',
						msg : '错误信息：访问服务器错误或网络不可用！请检查网络重试！'
					});
				}
			}
		}
	});
}

function _alert(obj) {
	if ( typeof obj == "object") {
		api.alert({
			msg : JSON.stringify(obj)
		}, function(ret, err) {
		});
	} else {
		api.alert({
			msg : obj
		}, function(ret, err) {
		});
	}
}

// 监听事件
function _addEventListener(eventName, _call, extra) {
	var _extra = ( typeof arguments[2] == "undefined" || arguments[2] == null) ? {} : arguments[2];
	api.addEventListener({
		name : eventName,
		extra : _extra
	}, function(ret, err) {
		if ( typeof _call == "function") {
			_call(ret);
		}
	});
}

//广播事件
function _sendEvent(eventName, extra) {
	var _extra = ( typeof arguments[1] == "undefined" || arguments[1] == null) ? {} : arguments[1];
	api.sendEvent({
		name : eventName,
		extra : _extra
	});
}

// 判断是否是IOS
function _isIOS() {
	return api.systemType == "ios" ? true : false;
}

// 获取文件拓展名
function _getExt(fileName) {
	return fileName.substring(fileName.lastIndexOf('.') + 1);
}

// 图片压缩
// imageFilter:压缩对象
// imgsrc：源图片的路径
// quality：图片压缩质量，一般建议0.5
// scale：图片压缩比例，也是建议0.5
// ext：源图片拓展名
// callback：转换成功之后回调函数
function _imgCompress(imageFilter, imgsrc, quality, scale, ext, callback) {
	// 压缩文件的保存目录
	var savePath = api.cacheDir + "/" + _getNowFormatDate() + "/";
	// 压缩文件生成的随机文件名称
	var savename = _newGuid() + "." + ext;
	imageFilter.compress({
		img : imgsrc,
		quality : quality,
		scale : quality,
		save : {
			album : false,
			imgPath : savePath,
			imgName : savename
		}
	}, function(ret, err) {
		if (ret) {
			callback(savePath + savename);
		} else {
			alert(JSON.stringify(err));
		}
	});
}

// 获取当前的时间，拼接成2015-11-09这样的格式，主要用于对图片进行时间分类
function _getNowFormatDate() {
	var date = new Date();
	var seperator1 = "-";
	var year = date.getFullYear();
	var month = date.getMonth() + 1;
	var strDate = date.getDate();
	if (month >= 1 && month <= 9) {
		month = "0" + month;
	}
	if (strDate >= 0 && strDate <= 9) {
		strDate = "0" + strDate;
	}
	var currentdate = year + seperator1 + month + seperator1 + strDate
	return currentdate;
}

// 滚动到底部
function _scrollToEnd() {
	document.getElementsByTagName('body')[0].scrollTop = document.getElementsByTagName('body')[0].scrollHeight;
}

function S4() {
	return (((1 + Math.random()) * 0x10000) | 0).toString(16).substring(1);
}

// 生成guid,主要用于生成随机文件名
function _newGuid() {
	return (S4() + S4() + "-" + S4() + "-" + S4() + "-" + S4() + "-" + S4() + S4() + S4());
}

function _newGuid2() {
	return (S4() + S4() + S4() + S4() + S4() + S4() + S4() + S4());
}

// 时间戳转时间
function _formatDate(timespan) {
	var now = new Date(timespan);
	var year = now.getFullYear();
	var month = now.getMonth() + 1;
	var date = now.getDate();
	var hour = now.getHours();
	var minute = now.getMinutes();
	var second = now.getSeconds();
	//year + "-" +
	// + ":" + (second < 10 ? '0' + second : second)
	// (month < 10 ? '0' + month : month) + "-" + (date < 10 ? '0' + date : date) + " " +
	return (month < 10 ? '0' + month : month) + "-" + (date < 10 ? '0' + date : date) + " " + (hour < 10 ? '0' + hour : hour) + ":" + (minute < 10 ? '0' + minute : minute);
}

// 时间戳转时间
function _formatDate1(timespan) {
	var now = new Date(timespan);
	var year = now.getFullYear();
	var month = now.getMonth() + 1;
	var date = now.getDate();
	var hour = now.getHours();
	var minute = now.getMinutes();
	var second = now.getSeconds();
	//year + "-" +
	// + ":" + (second < 10 ? '0' + second : second)
	// (month < 10 ? '0' + month : month) + "-" + (date < 10 ? '0' + date : date) + " " +
	return (hour < 10 ? '0' + hour : hour) + ":" + (minute < 10 ? '0' + minute : minute);
}

// 时间戳转时间
function _formatDate2(timespan) {
	var now = new Date(timespan);
	var year = now.getFullYear();
	var month = now.getMonth() + 1;
	var date = now.getDate();
	var hour = now.getHours();
	var minute = now.getMinutes();
	var second = now.getSeconds();
	//year + "-" +
	// + ":" + (second < 10 ? '0' + second : second)
	return year + "-" + (month < 10 ? '0' + month : month) + "-" + (date < 10 ? '0' + date : date) + " " + (hour < 10 ? '0' + hour : hour) + ":" + (minute < 10 ? '0' + minute : minute);
}

// 只需要日期
function _formatDate3(timespan) {
	var now = new Date(timespan);
	var year = now.getFullYear();
	var month = now.getMonth() + 1;
	var date = now.getDate();
	//year + "-" +
	// + ":" + (second < 10 ? '0' + second : second)
	// (month < 10 ? '0' + month : month) + "-" + (date < 10 ? '0' + date : date) + " " +
	return year + "-" + (month < 10 ? '0' + month : month) + "-" + (date < 10 ? '0' + date : date);
}

// 获取文件拓展名
function _getExt(fileName) {
	return fileName.substring(fileName.lastIndexOf('.') + 1);
}

function _prefixInteger(num, length) {
	return (Array(length).join('0') + num).slice(-length);
}

function _exit() {
	//						if (api.systemType == 'android') {
	//							api.closeWidget({
	//								silent : true
	//							});
	//						} else {
	//							api.openWin({
	//								slidBackEnabled: false,
	//								name : 'root',
	//								url : '../index.html',
	//								reload : true
	//							});
	//						}
	//让事件处理完
	setTimeout(_exitatonce(), 500);
}

function _exitatonce() {
	api.execScript({
		name : 'root',
		script : 'apiready();'
	});
	api.closeToWin({
		name : 'root'
	});
}
