var userJson = null, timer = null;
var lastMessageId = 0;
var lastdate = '';
var firstMessageId = 0;
var firstdate = '';
var expiredatelong = 0;
// 生成发送消息样式
function writeSenderMsg(msgObj, isnew) {
	// 获取消息类型
	var msgtype = msgObj.msgtype;
	switch(msgtype) {
		// 文本类型
		case "text":
			var addon = '';
			if (msgObj.extra) {
				addon = $api.strToJson(msgObj.extra).addon;
			}
			msgObj.msgcontent = _transEmo(msgObj.msgcontent) + addon;
			break;
	}
	//先把发送的删除掉
	$("#" + msgObj.uuid).remove();
	var interText = doT.template($("#senderTpl").text());
	if (isnew) {
		$("#message-content").append(interText(msgObj));
		//TODO 判断是否滚动位置是否在底部，如果在底部进行刷新，不在则不进行刷新，在傍边显示有新消息提醒
		setTimeout(function() {
			_scrollToEnd();
		}, 300);
	} else {
		//历史消息放到前面，并且不做滚动到底部
		$("#message-content").prepend(interText(msgObj));
	}
}
// 生成日期分隔线
function writeDivideDate(msgObj, isnew) {
	var interText = doT.template($("#dateTpl").text());
	if (isnew) {
		$("#message-content").append(interText(msgObj));
		setTimeout(function() {
			_scrollToEnd();
		}, 300);
	} else {
		$("#message-content").prepend(interText(msgObj));
	}	
}

// 生成接受信息样式
function writeReceiverMsg(msgObj, isnew) {
	// 获取接收类型
	var msgtype = msgObj.msgtype;
	switch(msgtype) {
		// 文本类型
		case "text":
			var addon = '';
			if (msgObj.extra) {
				addon = $api.strToJson(msgObj.extra).addon;
			}
			msgObj.msgcontent = _transEmo(msgObj.msgcontent) + addon;
			break;
	}
	var interText = doT.template($("#receiverTpl").text());
	if (isnew) {
		$("#message-content").append(interText(msgObj));
		setTimeout(function() {
			_scrollToEnd();
		}, 300);
	} else {
		$("#message-content").prepend(interText(msgObj));
	}
}

function getnewmessages() {
	_ajax('api/v1/message/getnewmessages', {
		targetId : api.pageParam.targetId,
		lastMessageId : lastMessageId
	}, {
		Authorization : 'Bearer ' + userJson.access_token
	}, false, function(ret) {
		//清理一下列表上未读数
		if (userJson.usertype == 'a') {
			api.execScript({
				name : 'asker1_win',
				frameName : 'asker1_frm_1',
				script : 'clearunread(' + api.pageParam.targetId + ');'
			});
		} else {
			api.execScript({
				name : 'consultant1_win',
				frameName : 'consultant1_frm_1',
				script : 'clearunread(' + api.pageParam.targetId + ');'
			});
		}
		if (ret.messages && ret.messages.length > 0) {
			//倒序循环
			if (firstMessageId == 0) {
				firstMessageId = ret.messages[ret.messages.length - 1].id;
				firstdate = _formatDate3(ret.messages[ret.messages.length - 1].msgtime);
				lastdate = _formatDate3(ret.messages[ret.messages.length - 1].msgtime);
			}
			lastMessageId = ret.messages[0].id;
			for (var i = ret.messages.length; i > 0; i--) {
				var msgObj = ret.messages[i - 1];
				var mydate = _formatDate3(msgObj.msgtime);
				if (mydate != lastdate) {
					lastdate = mydate;
					writeDivideDate(msgObj, true);
				}
				
				if (msgObj.senduserid == userJson.userid) {
					writeSenderMsg(msgObj, true);
				} else {
					writeReceiverMsg(msgObj, true);
				}
			}
		}
	});
}

function getlastmessages() {
	//先取一次
	_ajax('api/v1/message/getlastmessages', {
		targetId : api.pageParam.targetId
	}, {
		Authorization : 'Bearer ' + userJson.access_token
	}, false, function(ret) {
		//1、设置标题（特殊处理）
		var maintitle = '';
		var subtitle = '';
		if (userJson.usertype == 'a') {
			if (ret.room.status == 2) {
				maintitle = ret.room.targetdomain + ret.conversation.title;
				subtitle = '结束时间：' + _formatDate2(ret.room.enddate);
				var enddate = new Date(ret.room.enddate);
				expiredatelong = enddate.getTime();
			} else {
				maintitle = ret.conversation.title;
				subtitle = '可随时随地发起咨询';
			}
		} else if (userJson.usertype == 'c') {
			//还有c对c
			maintitle = ret.room.targetdomain + ret.conversation.title;
			if (ret.room.status == 1) {
				subtitle = '最佳时间：';
			} else {
				subtitle = '结束时间：';
			}
			subtitle = subtitle + _formatDate2(ret.room.enddate);
		}
		api.execScript({
			name : 'chat1_win',
			script : 'setTitle("' + maintitle + '","' + subtitle + '","' + ret.room.avatarurl + '");'
		});
		//2、输出messages列表，并记录最后一个，和最前面一个的id值
		if (ret.messages && ret.messages.length > 0) {
			//倒序循环
			firstMessageId = ret.messages[ret.messages.length - 1].id;
			firstdate = _formatDate3(ret.messages[ret.messages.length - 1].msgtime);
			lastMessageId = ret.messages[0].id;
			lastdate = _formatDate3(ret.messages[ret.messages.length - 1].msgtime);
			for (var i = ret.messages.length; i > 0; i--) {
				var msgObj = ret.messages[i - 1];
				//hy add divide date line
				var mydate = _formatDate3(msgObj.msgtime);
				if (mydate != lastdate) {
					lastdate = mydate;
					writeDivideDate(msgObj, true);
				}
				if (msgObj.senduserid == userJson.userid) {
					writeSenderMsg(msgObj, true);
				} else {
					writeReceiverMsg(msgObj, true);
				}
			}
		}
		//3、启动定时器，定时接收最新的消息
		if (!timer)
			timer = window.setInterval(getnewmessages, window.messageInternal);
		//最大问题是第一没有获得成功，那么定时取消息只能从0点开始获取
	});
}

function gethismessages() {
	_ajax('api/v1/message/gethismessages', {
		targetId : api.pageParam.targetId,
		firstMessageId : firstMessageId
	}, {
		Authorization : 'Bearer ' + userJson.access_token
	}, false, function(ret) {
		api.refreshHeaderLoadDone();
		if (ret.messages && ret.messages.length > 0) {
			//倒序循环
			if (lastMessageId == 0) {
				lastMessageId = ret.messages[0].id;
				firstdate = _formatDate3(ret.messages[0].msgtime);
				lastdate = _formatDate3(ret.messages[0].msgtime);
			}
			firstMessageId = ret.messages[ret.messages.length - 1].id;
			for (var i = 0; i < ret.messages.length; i++) {
				var msgObj = ret.messages[i];
				//hy add divide date line
				var mydate = _formatDate3(msgObj.msgtime);
				if (mydate != firstdate) {
					firstdate = mydate;
					writeDivideDate(msgObj, false);
				}
				
				if (msgObj.senduserid == userJson.userid) {
					writeSenderMsg(msgObj, false);
				} else {
					writeReceiverMsg(msgObj, false);
				}
			}
		} else {
			api.toast({
				location : 'top',
				msg : '已到了最后一条！'
			});
		}
	});
}

apiready = function() {
	api.parseTapmode();
	userJson = $api.getStorage(window.userKey);
	// 下拉获得更多的历史消息，下拉获得更多
	api.setRefreshHeaderInfo({
		visible : true,
		bgColor : "#F3F2F0",
		textColor : "#999",
		textDown : '下拉显示更多...',
		textUp : '松开刷新...',
		showTime : true
	}, function(ret, err) {
		gethismessages();
	});
	//获得最后的消息
	getlastmessages();
	_addEventListener("scrollButton", function() {
		setTimeout(function() {
			_scrollToEnd();
		}, 300);
	});
	_addEventListener("sendMsgStart", function(ret) {
		if (ret && ret.value) {
			var msgObj = ret.value;
			if (expiredatelong > 0 && msgObj.msgtime > expiredatelong) {
				_alert('此咨询室服务已过期，请先续费！');
			} else {
				_sendEvent("sendMsgPrepare", msgObj);
				_ajax('api/v1/message/sendmessage', msgObj, {
					Authorization : 'Bearer ' + userJson.access_token
				}, false, function(ret) {
					if (ret.errcode > 0) {
						//错误
						_sendEvent("sendMsgError", msgObj);
					} else {
						//完成
						_sendEvent("sendMsgSuccess", msgObj);
					}
				});
			}
		}
	});
	_addEventListener("sendMsgPrepare", function(ret) {
		if (ret && ret.value) {
			var msg = ret.value;
			writeSenderMsg(msg, true);
			$(".aui-timeline-footer[data-uuid='" + msg.uuid + "']").find(".aui-chat-status").removeClass("winu-display-none");
		}
	});
	_addEventListener("sendMsgSuccess", function(ret) {
		if (ret && ret.value) {
			var msg = ret.value;
			$(".aui-timeline-footer[data-uuid='" + msg.uuid + "']").find(".aui-chat-status").addClass("winu-display-none");
		}
	});
	_addEventListener("sendMsgError", function(ret) {
		if (ret && ret.value) {
			var msg = ret.value;
			$(".aui-timeline-footer[data-uuid='" + msg.uuid + "']").find(".aui-chat-status i").attr("class", "aui-iconfont aui-icon-roundclose").css("color", "#f00");
		}
	});
	_addEventListener("logout", function(ret) {
		//停止轮训
		if (timer) {
			window.clearInterval(timer);
			timer = null;
		}
	});
	api.addEventListener({
		name : 'pause'
	}, function(ret, err) {
		if (timer) {
			window.clearInterval(timer);
			timer = null;
		}
	});
	api.addEventListener({
		name : 'resume'
	}, function(ret, err) {
		if (!timer)
			timer = window.setInterval(getnewmessages, window.messageInternal);
		//恢复后，马上拉一次消息
		getnewmessages();
	});
};
function openProfileWin(usertype, userid) {
	api.openWin({
		name : 'profile_win',
		url : './profile_win.html',
		pageParam : {
			usertype : usertype,
			userid : userid
		}
	});
}